<template>
  <div class="card-container card-group">
    <div class="card text-white bg-dark mb-3" style="max-width: 18rem;">
      <div class="card-header">Inventory ID: {{ id }}</div>
      <div class="card-body">
        <h5 class="card-title">Inventory description: </h5>
        <p class="card-text">{{ body }}</p>
      </div>
      <div class="card-footer text-right">
        <div class="row">
          <div class="col" style="text-align: left;">
            <button type="button" class="btn btn-success" style="margin: 4px;" @click="handleOpen(id)">
              <!-- This is the code for the list icon. -->
              <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-list-ol" viewBox="0 0 16 16">
                <path fill-rule="evenodd" d="M5 11.5a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5z"/>
                <path d="M1.713 11.865v-.474H2c.217 0 .363-.137.363-.317 0-.185-.158-.31-.361-.31-.223 0-.367.152-.373.31h-.59c.016-.467.373-.787.986-.787.588-.002.954.291.957.703a.595.595 0 0 1-.492.594v.033a.615.615 0 0 1 .569.631c.003.533-.502.8-1.051.8-.656 0-1-.37-1.008-.794h.582c.008.178.186.306.422.309.254 0 .424-.145.422-.35-.002-.195-.155-.348-.414-.348h-.3zm-.004-4.699h-.604v-.035c0-.408.295-.844.958-.844.583 0 .96.326.96.756 0 .389-.257.617-.476.848l-.537.572v.03h1.054V9H1.143v-.395l.957-.99c.138-.142.293-.304.293-.508 0-.18-.147-.32-.342-.32a.33.33 0 0 0-.342.338v.041zM2.564 5h-.635V2.924h-.031l-.598.42v-.567l.629-.443h.635V5z"/>
              </svg>
              <!-- End of the code for the list icon -->
            </button>
          </div>
          <div class="col" style="text-align: right; white-space: nowrap;">
            <!-- Cog button. At click, a modal is opened to allow the user to modify an item. -->
            <button type="button" class="btn btn-secondary" style="margin: 5px;" @click="handleEdit(id)">
              <!-- This is the code for the cog icon. -->
              <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-gear-fill" viewBox="0 0 16 16">
                <path d="M9.405 1.05c-.413-1.4-2.397-1.4-2.81 0l-.1.34a1.464 1.464 0 0 1-2.105.872l-.31-.17c-1.283-.698-2.686.705-1.987 1.987l.169.311c.446.82.023 1.841-.872 2.105l-.34.1c-1.4.413-1.4 2.397 0 2.81l.34.1a1.464 1.464 0 0 1 .872 2.105l-.17.31c-.698 1.283.705 2.686 1.987 1.987l.311-.169a1.464 1.464 0 0 1 2.105.872l.1.34c.413 1.4 2.397 1.4 2.81 0l.1-.34a1.464 1.464 0 0 1 2.105-.872l.31.17c1.283.698 2.686-.705 1.987-1.987l-.169-.311a1.464 1.464 0 0 1 .872-2.105l.34-.1c1.4-.413 1.4-2.397 0-2.81l-.34-.1a1.464 1.464 0 0 1-.872-2.105l.17-.31c.698-1.283-.705-2.686-1.987-1.987l-.311.169a1.464 1.464 0 0 1-2.105-.872l-.1-.34zM8 10.93a2.929 2.929 0 1 1 0-5.86 2.929 2.929 0 0 1 0 5.858z"/>
              </svg>
              <!-- End of the code for the cog icon. -->
            </button>
            <!-- Trash button. At click, user is redirected to the page where the inventory can be updated. -->
            <button type="button" class="btn btn-danger" style="margin: 5px;" @click="handleDelete(id)">
              <!-- This is the code for the trash icon. -->
              <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-trash-fill" viewBox="0 0 16 16">
                <path d="M2.5 1a1 1 0 0 0-1 1v1a1 1 0 0 0 1 1H3v9a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V4h.5a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1H10a1 1 0 0 0-1-1H7a1 1 0 0 0-1 1H2.5zm3 4a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7a.5.5 0 0 1 .5-.5zM8 5a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7A.5.5 0 0 1 8 5zm3 .5v7a.5.5 0 0 1-1 0v-7a.5.5 0 0 1 1 0z"/>
              </svg>
              <!-- End of the code for the trash icon. -->
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
// Importing axios to make requests to the backend.
import axios from 'axios'
export default {
  name: 'Invcard',
  // Inheriting variables from parent classes
  props: {
    id: Number,
    body: String
  },
  data () {
    return {
      baseUrl: 'http://localhost:8000/api/',
      inven: null
    }
  },
  methods: {
    // emit methods send signals to the parent classes, instructing them to start a method
    handleOpen (id) {
      this.$emit('open-inventory', id)
    },
    handleDelete (id) {
      this.$emit('delete-inventory', id)
    },
    // method to get a specific inventory data and pass it to the parent class
    async handleEdit (id) {
      await axios.get(this.baseUrl + 'inventory', {
        params: {
          inventory_id: this.id
        }
      }).then(response => {
        this.inven = response.data[0]
      })
      this.$emit('selected-inventory', this.inven)
    }
  }
}
</script>
